#undef	NOVLONG
#undef	NOFLOAT
#undef	NOBIT

typedef	struct	Type	Type;

struct	Type
{
	schar		sc;
	uchar		uc;
	short		sh;
	ushort		uh;
	int		si;
	uint		ui;
	long		sl;
	ulong		ul;
#ifndef	NOVLONG
	vlong		sv;
	uvlong		uv;
#else
	int		sv;
	int		uv;
#endif
#ifndef	NOFLOAT
	float		ff;
	double		df;
#else
	int		ff;
	int		df;
#endif
#ifndef	NOBIT
	long		sb:15;
	ulong		ub:15;
#else
	int		sb;
	int		ub;
#endif
};

void	settype(Type*, int);
void	tsttype(Type*, Type*, char*, char*);
void	tsttype1(Type*, Type*, char*, char*);

void	add(void);
void	and(void);
void	asadd(void);
void	asand(void);
void	asdiv(void);
void	aslsh(void);
void	asmod(void);
void	asmul(void);
void	asor(void);
void	asrsh(void);
void	assign(void);
void	assub(void);
void	asxor(void);
void	div(void);
void	lsh(void);
void	mod(void);
void	mul(void);
void	or(void);
void	postdec(void);
void	postinc(void);
void	predec(void);
void	preinc(void);
void	rsh(void);
void	sub(void);
void	xor(void);
